﻿namespace Battleship;

/// <summary>
/// Класс-сущность Линкор
/// </summary>
public class EntityBattleship
{
    /// <summary>
    /// Скорость
    /// </summary>
    public int Speed {  get; private set; }
    /// <summary>
    /// Вес
    /// </summary>
    public double Weight { get; private set; }
    /// <summary>
    /// Основной цвет 
    /// </summary>
    public Color BodyColor { get; private set; }
    /// <summary>
    /// Дополнительный цвет (для опциональных элементов)
    /// </summary>
    public Color AdditionalColor { get; private set; }
    /// <summary>
    /// Признак (опция) наличия палубы
    /// </summary>
    public bool BodyDeck {  get; private set; } 
    /// <summary>
    /// Признак (опция) отсека для ракет
    /// </summary>
    public bool Compartment { get; private set; } 
    /// <summary>
    /// Признак (опция) наличия башни
    /// </summary>
    public bool Tower { get; private set; } 
    /// <summary>
    /// Перемещение линкора
    /// </summary>
    public double Step => Speed * 100 / Weight;

    /// <summary>
    /// Инициализация полей объекта-класса линкора
    /// </summary>
    /// <param name="speed"></param>
    /// <param name="weight"></param>
    /// <param name="bodyColor"></param>
    /// <param name="additionalColor"></param>
    /// <param name="bodyDeck"></param>
    /// <param name="compartment"></param>
    /// <param name="tower"></param>
    public void Init(int speed, double weight, Color bodyColor, Color additionalColor, bool bodyDeck, bool compartment, bool tower)
    {
        Speed = speed;
        Weight = weight;
        BodyColor = bodyColor;
        AdditionalColor = additionalColor;
        BodyDeck = bodyDeck;
        Compartment = compartment;
        Tower = tower;
    }
}