﻿namespace Battleship;
/// <summary>
/// Форма работы с объектом Линкор
/// </summary>
public partial class FormBattleship : Form
{
    /// <summary>
    /// Поле/объект для прорисовки объекта
    /// </summary>
    private DrawingBattleship? _drawingBattleship; //поля с нижнего подчеркивания

    public FormBattleship()
    {
        InitializeComponent();
    }
    /// <summary>
    /// Метод прорисовки машины
    /// </summary>
    //создаем отдельный метод
    private void Draw()
    {
        if (_drawingBattleship == null)
        {
            return;
        }

        Bitmap bmp = new(pictureBoxBattleship.Width, pictureBoxBattleship.Height);
        Graphics gr = Graphics.FromImage(bmp);
        _drawingBattleship.DrawTransport(gr);
        pictureBoxBattleship.Image = bmp;

    }
    /// <summary>
    /// обработка нажатия кнопки "создать линкор"
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void buttonCreate_Click(object sender, EventArgs e)
    {
        Random random = new();
        _drawingBattleship = new DrawingBattleship();
        _drawingBattleship.Init(random.Next(100, 300), random.Next(1000, 3000),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)));
        _drawingBattleship.SetPictureSize(pictureBoxBattleship.Width, pictureBoxBattleship.Height);
        _drawingBattleship.SetPosition(random.Next(10, 100), random.Next(10, 100), pictureBoxBattleship.Width, pictureBoxBattleship.Height);

        Draw();

    }

    /// <summary>
    /// обработка нажатия кнопок "вверх/вниз/влево/вправо"
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void buttonMove_Click(object sender, EventArgs e)
    {
        if (_drawingBattleship == null)
        {
            return;
        }

        string name = ((Button)sender)?.Name ?? string.Empty;
        bool result = false;
        switch (name)
        {
            case "buttonUp":
                result = _drawingBattleship.MoveTransport(DirectionType.Up); 
                break;
            case "buttonDown":
                result = _drawingBattleship.MoveTransport(DirectionType.Down);
                break;
            case "buttonLeft":
                result = _drawingBattleship.MoveTransport(DirectionType.Left);
                break;
            case "buttonRight":
                result = _drawingBattleship.MoveTransport(DirectionType.Right);
                break;
        }

        if (result)
        {
            Draw();
        }
    }
}